#ifndef CPT_H_
#define CPT_H_
#include "../../../CPT/src/cpt.h"
#include "../../../CPT/src/structs.h"
#include "../../../CPT/src/instantiation.h"
#include "../../../CPT/src/problem.h"
#include "../../../CPT/src/plan.h"
//#include "../../../CPT/src/dae.h"
#include "../../../CPT/src/globs.h"
#include "../../../CPT/src/timer.h"
#include "../../../CPT/src/propagations.h"
#include "../../../CPT/src/solve.h"
#include "../../../CPT/src/trace_planner.h"
#include "../../../CPT/src/resources.h"
#include "../../../CPT/src/branching.h"
#include "../../../CPT/src/max_atom.h"
#include "../../../CPT/src/preprocess.h"
#include "../../../CPT/src/scheduling.h"
//#include "../../../CPT/src/dae.h"



void CPTinformationDAE(void){
	printf("\nProblem : %ld actions, %ld fluents, %ld causals\n          %ld init facts, %ld goals\n\n",
	 actions_nb, fluents_nb, causals_nb, start_action->add_nb, end_action->prec_nb);
	 printf("World size : %ldK\n", world_size());
	 printf("max_plan_length : %ld\n", opt.max_plan_length);
	printf("distance : %ld\n", opt.distances);
	printf(" resources_nb : %ld\n",resources_nb );
	printf("Mutex choices : %ld\n", nb_mutex_choices);
	printf( "Nodes : %ld\n", nb_nodes());
    printf( "Backtracks : %ld\n", nb_backtracks());
    printf( "Support choices : %ld\n", nb_support_choices);
    printf( "Conflict choices : %ld\n", nb_conflict_choices);
    printf( "Mutex choices : %ld\n", nb_mutex_choices);
    printf( "Start time choices : %ld\n", nb_start_time_choices);
    printf( "World size : %ldK\n", world_size() / 1000);
  // printf("\nLength : %ld\n", solution_plan->steps_nb);
}

int CPTmaxbks(void){
	int a=nb_nodes();
	int b=nb_conflict_choices;
	if(b >0 && end_action->prec_nb>0 && fluents_nb>0) return  end_action->prec_nb*(a/b +2*(causals_nb+actions_nb)/fluents_nb); 
	else return 2000 ;
}
int CPTbksC(void){return nb_nodes()/20;}
int CPTmaxbksGoal(void){
	return 2*causals_nb;//CPTmaxbks()*end_action->prec_nb*2;
}


#endif /*CPT_H_*/

